﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Security;

namespace AceGrep
{
    class AceList
    {
        const bool APPEND = true;
        const int ARRAY_SIZE_ERROR = 4;
        const int DRIVE_COLON_SIZE = 2;
        const int IO_ERROR = 5;
        const int REGEX_ERROR = 3; // errorLevel > 2
        const int SAFE_AND_SOUND = 0;
        const string REGULAR_EXPRESSION_COLON = "Regular expression: ";
        const string SEPARATOR = "\\";

        bool closeSubdirectoryGate, showRegularExpression, throughSubdirectories;
        int hierarchyArraySize;
        int hierarchyLebel = 0;
        Regex x;
        string CURRENT_DIRECTORY, fileNameListText;
        string DRIVE_COLON = "C:";
        string path = "C:";
        string re = ".*";
        string wildCards = "*";
        string[] hierarchy = {"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", };
        StreamWriter listFile;

        public int internalMethod(string item)
        {
            int exitCode = SAFE_AND_SOUND;
            DirectoryInfo directory_info = new DirectoryInfo(CURRENT_DIRECTORY);

            listFile = new StreamWriter(fileNameListText, APPEND, Encoding.Default);

            DRIVE_COLON = CURRENT_DIRECTORY.Substring(0, DRIVE_COLON_SIZE);

            WildCardToRegularExpression w = new WildCardToRegularExpression(item);
            re = w.converted();

            if (showRegularExpression)
            {
                Console.Write(REGULAR_EXPRESSION_COLON);
                Console.WriteLine(re);
            }

            try
            {
                x = new Regex(re);
                hierarchyArraySize = hierarchy.Length;

                if (closeSubdirectoryGate)
                {
                    non_recursive(directory_info);
                }
                else
                {
                    recursiveFunction(directory_info);
                }

                listFile.Close();
            }
            catch (ArgumentException e172)
            {
                exitCode = REGEX_ERROR;
                Error.handler(e172.ToString());
            }
            catch (IOException e173)
            {
                exitCode = IO_ERROR;
                Error.handler(e173.ToString());
            }

            return exitCode;
        }

        private void non_recursive(DirectoryInfo directory_info)
        {
            try
            {
                FileInfo[] file_info = directory_info.GetFiles();
                Match m;
                string name;

                foreach (FileInfo file in file_info)
                {
                    name = file.Name;
                    m = x.Match(name);
                    if(m.Success)
                    {
                        listFile.WriteLine(name);
                    }

                }

            }
            catch
            {
            }

        }

        private void recursiveFunction(DirectoryInfo directory_info)
        {
            hierarchyLebel += 1;
            if (hierarchyLebel >= hierarchyArraySize)
            {
                Console.Error.WriteLine("hierarchyLebel >= hierarchyArraySize");
                System.Environment.Exit(ARRAY_SIZE_ERROR);
            }

            hierarchy[hierarchyLebel] = directory_info.Name;

            path = DRIVE_COLON;
            for (int i = 1; i <= hierarchyLebel; ++i)
            {
                path += SEPARATOR;
                path += hierarchy[i];
            }

            try
            {
                FileInfo[] file_info = directory_info.GetFiles();
                Match m;
                string name;

                foreach (FileInfo file in file_info)
                {
                    name = file.Name;
                    m = x.Match(name);
                    if(m.Success)
                    {
                        listFile.Write(path);
                        listFile.Write(SEPARATOR);
                        listFile.WriteLine(name);
                    }

                }

                DirectoryInfo[] directories = directory_info.GetDirectories();

                foreach (DirectoryInfo new_directory_info in directories)
                {
                    recursiveFunction(new_directory_info);
                    hierarchyLebel -= 1;
                }

            }
            catch
            {
            }

        }

        public AceList(string f, string w, bool c, bool s, bool t)
        {
            CURRENT_DIRECTORY = Environment.CurrentDirectory;
            fileNameListText = f;
            wildCards = w;
            closeSubdirectoryGate = c; // reduceToCurrentDirectory
            showRegularExpression = s;
            throughSubdirectories = t;
        }

    }
}
