﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class FileLine : Perusable
    {
        public override bool reading()
        {
            bool b = false;
            string fileNameSeparator = label + separator;
            string line = EMPTY;

            try
            {
                for (; ; )
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        b = true;
                        Console.Write(fileNameSeparator);
                        Console.WriteLine(line);
                    }

                }

            }
            catch (IOException e83)
            {
                Error.handler(e83.ToString());
                plus("IOException e83");
            }

            return b;
        }

        public override bool reading(string fileName)
        {
            bool b = false;
            string fileNameSeparator = fileName + separator;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);

                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        b = true;
                        Console.Write(fileNameSeparator);
                        Console.WriteLine(line);
                    }

                }

                file.Close();
            }
            catch (IOException e84)
            {
                Error.handler(e84.ToString());
                plus("IOException e84");
            }

            return b;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool b = false;
            string fileNameSeparator = fileName + separator;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, encoding);
                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        b = true;
                        Console.Write(fileNameSeparator);
                        Console.WriteLine(line);
                    }

                }

                file.Close();
            }
            catch (IOException e85)
            {
                Error.handler(e85.ToString());
                plus("IOException e85");
            }

            return b;
        }

        public FileLine(string re, bool insensitive)
        {
            case_sensitive = !insensitive;

            if (compiling(re))
            {
                error = EMPTY;
            }
            else
            {
                error = "compiling(re): /" + re + "/";
            }

        }

    }
}
