﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class FileLineLimited : Perusable
    {
        int maximumLineCount;

        public override bool reading()
        {
            bool found = false;
            int count = 0;
            string fileNameSeparator = label + separator;
            string line = EMPTY;

            try
            {
                while(count < maximumLineCount) 
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        Console.Write(fileNameSeparator);
                        Console.WriteLine(line);
                        count += 1;
                    }

                }

                if(count > 0) {
                    found = true;
                }

            }
            catch (IOException e127)
            {
                Error.handler(e127.ToString());
                plus("IOException e127");
            }

            return found;
        }

        public override bool reading(string fileName)
        {
            bool found = false;
            int count = 0;
            string fileNameSeparator = fileName + separator;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);

                while(count < maximumLineCount) 
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        Console.Write(fileNameSeparator);
                        Console.WriteLine(line);
                        count += 1;
                    }

                }

                file.Close();
                if(count > 0) {
                    found = true;
                }

            }
            catch (IOException e128)
            {
                Error.handler(e128.ToString());
                plus("IOException e128");
            }

            return found;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool found = false;
            int count = 0;
            string fileNameSeparator = fileName + separator;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, encoding);

                while(count < maximumLineCount) 
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        Console.Write(fileNameSeparator);
                        Console.WriteLine(line);
                        count += 1;
                    }

                }

                file.Close();
                if(count > 0) {
                    found = true;
                }

            }
            catch (IOException e129)
            {
                Error.handler(e129.ToString());
                plus("IOException e129");
            }

            return found;
        }

        public FileLineLimited(string re, int m, bool insensitive)
        {
            case_sensitive = !insensitive;

            maximumLineCount = m;
            if (compiling(re))
            {
                error = EMPTY;
            }
            else
            {
                error = "compiling(re): /" + re + "/";
            }

        }

    }
}
