﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class FileNumberLine : Perusable
    {
        public override bool reading()
        {
            bool b = false;
            string fileNameSeparator = label + separator;
            string line = EMPTY;

            try
            {
                for (int lineNumber = 1; ; lineNumber += 1)
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        b = true;
                        Console.Write(fileNameSeparator);
                        Console.Write(lineNumber);
                        Console.Write(separator);
                        Console.WriteLine(line);
                    }

                }

            }
            catch (IOException e90)
            {
                Error.handler(e90.ToString());
                plus("IOException e90");
            }

            return b;
        }

        public override bool reading(string fileName)
        {
            bool b = false;
            string fileNameSeparator = fileName + separator;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);

                for (int lineNumber = 1; ; lineNumber += 1)
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        b = true;
                        Console.Write(fileNameSeparator);
                        Console.Write(lineNumber);
                        Console.Write(separator);
                        Console.WriteLine(line);
                    }

                }

                file.Close();
            }
            catch (IOException e91)
            {
                Error.handler(e91.ToString());
                plus("IOException e91");
            }

            return b;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool b = false;
            string fileNameSeparator = fileName + separator;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, encoding);
                for (int lineNumber = 1; ; lineNumber += 1)
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        b = true;
                        Console.Write(fileNameSeparator);
                        Console.Write(lineNumber);
                        Console.Write(separator);
                        Console.WriteLine(line);
                    }

                }

                file.Close();
            }
            catch (IOException e92)
            {
                Error.handler(e92.ToString());
                plus("IOException e92");
            }

            return b;
        }

        public FileNumberLine(string re, bool insensitive)
        {
            case_sensitive = !insensitive;

            if (compiling(re))
            {
                error = EMPTY;
            }
            else
            {
                error = "compiling(re): /" + re + "/";
            }

        }

    }
}
