﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace AceGrep
{
    public class FileRequired : Perusable
    {
        public override bool reading()
        {
            bool found = false;
    		string fileName = label;
            string line = EMPTY;

            try
            {
                for (; ; )
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        found = true;
                        Console.WriteLine(fileName);
                        break;
                    }

                }

            }
            catch (IOException e4)
            {
                Error.handler(e4.ToString());
                plus("IOException e4");
            }

            return found;
        }

        public override bool reading(string fileName)
        {
            bool found = false;

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);
                string line = EMPTY;

                for(; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        found = true;
                        Console.WriteLine(fileName);
                        break;
                    }

                }

                file.Close();
            }
            catch (IOException e5)
            {
                Error.handler(e5.ToString());
                plus("IOException e5");
            }

            return found;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool found = false;

            try {
                StreamReader file = new StreamReader(fileName, encoding);
                string line = EMPTY;

                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        found = true;
                        Console.WriteLine(fileName);
                        break;
                    }

                }

                file.Close();
            }
            catch (IOException e6)
            {
                Error.handler(e6.ToString());
                plus("IOException e6");
            }

            return found;
        }

        public FileRequired(string re, bool insensitive)
        {
            case_sensitive = !insensitive;

            if ( compiling(re) )
            {
                error = EMPTY;
            }
            else
            {
                error = "compiling(re): /" + re + "/" ;
            }

        }
    }
}
