﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class LineLimited : Perusable
    {
        int maximumLineCount;

        public override bool reading()
        {
            bool found = false;
            int count = 0;
            string line = EMPTY;

            try
            {
                while (count < maximumLineCount)
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        Console.WriteLine(line);
                        count += 1;
                    }

                }

                if(count > 0) {
                    found = true;
                }

            }
            catch (IOException e115)
            {
                Error.handler(e115.ToString());
                plus("IOException e115");
            }

            return found;
        }

        public override bool reading(string fileName)
        {
            bool found = false;
            int count = 0;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);

                while (count < maximumLineCount)
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        Console.WriteLine(line);
                        count += 1;
                    }

                }

                file.Close();
                if(count > 0) {
                    found = true;
                }

            }
            catch (IOException e116)
            {
                Error.handler(e116.ToString());
                plus("IOException e116");
            }

            return found;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool found = false;
            int count = 0;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, encoding);

                while (count < maximumLineCount)
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        Console.WriteLine(line);
                        count += 1;
                    }

                }

                file.Close();
                if(count > 0) {
                    found = true;
                }

            }
            catch (IOException e117)
            {
                Error.handler(e117.ToString());
                plus("IOException e117");
            }

            return found;
        }

        public LineLimited(string re, int m, bool insensitive)
        {
            case_sensitive = !insensitive;

            maximumLineCount = m;
            if (compiling(re))
            {
                error = EMPTY;
            }
            else
            {
                error = "compiling(re): /" + re + "/";
            }

        }

    }
}
