﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class LineLimitedRing : Perusable
    {
        int after, maximumLineCount, ring_count;
        Queue<string> ring = new Queue<string>();

        private void prepareRing()
        {
            ring.Clear();
            for (int i = 0; i < ring_count; ++i)
            {
                ring.Enqueue(GAP);
            }

        }

        private void showRing()
        {
            foreach (string s in ring)
            {
                Console.WriteLine(s);
            }

            Console.WriteLine(DASH);
        }

        public override bool reading()
        {
            bool found = false;
            bool written = false;
            int matchCount = 0;
            string line = EMPTY;
            prepareRing();

            try
            {
                if (after > 0)
                {
                    int count = 0;
                    for (; ; )
                    {
                        line = Console.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        if (found)
                        {
                            count += 1;
                            if (count >= after)
                            {
                                showRing();
                                prepareRing();
                                written = true;
                                if (matchCount < maximumLineCount)
                                {
                                    count = 0;
                                    found = false;
                                }
                                else
                                {
                                    break;
                                }

                            }

                        }

                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            found = true;
                            matchCount += 1;
                        }

                    }

                }
                else
                {
                    while(matchCount < maximumLineCount)
                    {
                        line = Console.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            found = true;
                            matchCount += 1;
                            showRing();
                            prepareRing();
                            written = true;
                        }

                    }

                }

                if (found)
                {
                    if (written)
                    {
                        ;
                    }
                    else
                    {
                        showRing();
                        written = true;
                    }

                }
                else
                {
                    found = (matchCount > 0) ? true : false;
                }

            }
            catch (InvalidOperationException e144)
            {
                Error.handler(e144.ToString());
                plus("InvalidOperationException e144");
                Console.Error.WriteLine(label);
            }
            catch (IOException e118)
            {
                Error.handler(e118.ToString());
                plus("IOException e118");
            }

            return found;
        }

        public override bool reading(string fileName)
        {
            bool found = false;
            bool written = false;
            int matchCount = 0;
            string line = EMPTY;
            prepareRing();

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);

                if (after > 0)
                {
                    int count = 0;
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);
                        if (found)
                        {
                            count += 1;
                            if (count >= after)
                            {
                                showRing();
                                prepareRing();
                                written = true;
                                if (matchCount < maximumLineCount)
                                {
                                    count = 0;
                                    found = false;
                                }
                                else
                                {
                                    break;
                                }

                            }

                        }

                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            found = true;
                            matchCount += 1;
                        }

                    }

                }
                else
                {
                    while(matchCount < maximumLineCount)
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            found = true;
                            matchCount += 1;
                            showRing();
                            prepareRing();
                            written = true;
                        }

                    }

                }

                file.Close();
                if (found)
                {
                    if (written)
                    {
                        ;
                    }
                    else
                    {
                        showRing();
                        written = true;
                    }

                }
                else
                {
                    found = (matchCount > 0) ? true : false;
                }

            }
            catch (InvalidOperationException e145)
            {
                Error.handler(e145.ToString());
                plus("InvalidOperationException e145");
                Console.Error.WriteLine(fileName);
            }
            catch (IOException e119)
            {
                Error.handler(e119.ToString());
                plus("IOException e119");
            }

            return found;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool found = false;
            bool written = false;
            int matchCount = 0;
            string line = EMPTY;
            prepareRing();

            try
            {
                StreamReader file = new StreamReader(fileName, encoding);

                if (after > 0)
                {
                    int count = 0;
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);
                        if (found)
                        {
                            count += 1;
                            if (count >= after)
                            {
                                showRing();
                                prepareRing();
                                written = true;
                                if (matchCount < maximumLineCount)
                                {
                                    count = 0;
                                    found = false;
                                }
                                else
                                {
                                    break;
                                }

                            }

                        }

                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            found = true;
                            matchCount += 1;
                        }

                    }

                }
                else
                {
                    while(matchCount < maximumLineCount)
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            found = true;
                            matchCount += 1;
                            showRing();
                            prepareRing();
                            written = true;
                        }

                    }

                }

                file.Close();
                if (found)
                {
                    if (written)
                    {
                        ;
                    }
                    else
                    {
                        showRing();
                        written = true;
                    }

                }
                else
                {
                    found = (matchCount > 0) ? true : false;
                }

            }
            catch (InvalidOperationException e146)
            {
                Error.handler(e146.ToString());
                plus("InvalidOperationException e146");
                Console.Error.WriteLine(fileName);
            }
            catch (IOException e120)
            {
                Error.handler(e120.ToString());
                plus("IOException e120");
            }

            return found;
        }

        public LineLimitedRing(String re, int a, int before, int m, bool insensitive)
        {
            after = a;
            case_sensitive = !insensitive;
            ring_count = before + 1 + after;
            maximumLineCount = m;

            if (compiling(re))
            {
                error = EMPTY;
            }
            else
            {
                error = "compiling(re): /" + re + "/";
            }

        }

    }
}
