﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class LineRing : Perusable
    {
        int after, ring_count;
        Queue<string> ring = new Queue<string>();

        private void prepareRing()
        {
            ring.Clear();
            for (int i = 0; i < ring_count; ++i)
            {
                ring.Enqueue(GAP);
            }

        }

        private void showRing()
        {
            foreach (string s in ring)
            {
                Console.WriteLine(s);
            }

            Console.WriteLine(DASH);
        }

        public override bool reading()
        {
            bool found = false;
            bool written = false;
            int sum = 0;
            string line = EMPTY;
            prepareRing();

            try
            {
                if (after > 0)
                {
                    int count = 0;
                    for (; ; )
                    {
                        line = Console.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        if (found)
                        {
                            count += 1;
                            if (count >= after)
                            {
                                showRing();
                                prepareRing();
                                written = true;
                                count = 0;
                                found = false;
                            }

                        }

                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            found = true;
                            sum += 1;
                        }

                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = Console.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            found = true;
                            sum += 1;
                            showRing();
                            prepareRing();
                            written = true;
                        }

                    }

                }

                if (found)
                {
                    if (written)
                    {
                        ;
                    }
                    else
                    {
                        showRing();
                        written = true;
                    }

                }
                else
                {
                    found = (sum > 0) ? true : false;
                }

            }
            catch (InvalidOperationException e147)
            {
                Error.handler(e147.ToString());
                plus("InvalidOperationException e147");
                Console.Error.WriteLine(label);
            }
            catch (IOException e72)
            {
                Error.handler(e72.ToString());
                plus("IOException e72");
            }

            return found;
        }

        public override bool reading(string fileName)
        {
            bool found = false;
            bool written = false;
            int sum = 0;
            string line = EMPTY;
            prepareRing();

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);

                if (after > 0)
                {
                    int count = 0;
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);
                        if (found)
                        {
                            count += 1;
                            if (count >= after)
                            {
                                showRing();
                                prepareRing();
                                written = true;
                                count = 0;
                                found = false;
                            }

                        }

                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            found = true;
                            sum += 1;
                        }

                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            found = true;
                            sum += 1;
                            showRing();
                            prepareRing();
                            written = true;
                        }

                    }

                }

                file.Close();
                if (found)
                {
                    if (written)
                    {
                        ;
                    }
                    else
                    {
                        showRing();
                        written = true;
                    }

                }
                else
                {
                    found = (sum > 0) ? true : false;
                }

            }
            catch (InvalidOperationException e148)
            {
                Error.handler(e148.ToString());
                plus("InvalidOperationException e148");
                Console.Error.WriteLine(fileName);
            }
            catch (IOException e73)
            {
                Error.handler(e73.ToString());
                plus("IOException e73");
            }

            return found;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool found = false;
            bool written = false;
            int sum = 0;
            string line = EMPTY;
            prepareRing();

            try
            {
                StreamReader file = new StreamReader(fileName, encoding);

                if (after > 0)
                {
                    int count = 0;
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);
                        if (found)
                        {
                            count += 1;
                            if (count >= after)
                            {
                                showRing();
                                prepareRing();
                                written = true;
                                count = 0;
                                found = false;
                            }

                        }

                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            found = true;
                            sum += 1;
                        }

                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            found = true;
                            sum += 1;
                            showRing();
                            prepareRing();
                            written = true;
                        }

                    }

                }

                file.Close();
                if (found)
                {
                    if (written)
                    {
                        ;
                    }
                    else
                    {
                        showRing();
                        written = true;
                    }

                }
                else
                {
                    found = (sum > 0) ? true : false;
                }

            }
            catch (InvalidOperationException e149)
            {
                Error.handler(e149.ToString());
                plus("InvalidOperationException e149");
                Console.Error.WriteLine(fileName);
            }
            catch (IOException e74)
            {
                Error.handler(e74.ToString());
                plus("IOException e74");
            }

            return found;
        }

        public LineRing(String re, int a, int before, bool insensitive)
        {
            after = a;
            case_sensitive = !insensitive;
            ring_count = before + 1 + after;

            if (compiling(re))
            {
                error = EMPTY;
            }
            else
            {
                error = "compiling(re): /" + re + "/";
            }

        }

    }
}
