﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class MatchCount : Perusable
    {
        public override bool reading()
        {
            bool b = false;
            string fileNameSeparator = label + separator;
            string line = EMPTY;

            try
            {
                int count = 0;
                for (; ; )
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        count += 1;
                    }

                }

                Console.WriteLine(fileNameSeparator + count.ToString());
                if (count > 0)
                {
                    b = true;
                }

            }
            catch (IOException e33)
            {
                Error.handler(e33.ToString());
                plus("IOException e33");
            }

            return b;
        }

        public override bool reading(string fileName)
        {
            bool b = false;

            try
            {
                int count = 0;
                StreamReader file = new StreamReader(fileName, Encoding.Default);
                string fileNameSeparator = fileName + separator;
                string line = EMPTY;

                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        count += 1;
                    }

                }

                file.Close();
                Console.WriteLine(fileNameSeparator + count.ToString());
                if (count > 0)
                {
                    b = true;
                }

            }
            catch (IOException e34)
            {
                Error.handler(e34.ToString());
                plus("IOException e34");
            }

            return b;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool b = false;

            try
            {
                int count = 0;
                StreamReader file = new StreamReader(fileName, encoding);
                string fileNameSeparator = fileName + separator;
                string line = EMPTY;
                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        count += 1;
                    }

                }

                file.Close();
                Console.WriteLine(fileNameSeparator + count.ToString());
                if (count > 0)
                {
                    b = true;
                }

            }
            catch (IOException e35)
            {
                Error.handler(e35.ToString());
                plus("IOException e35");
            }

            return b;
        }

        public MatchCount(string re, bool insensitive)
        {
            case_sensitive = !insensitive;

            if (compiling(re))
            {
                error = EMPTY;
            }
            else
            {
                error = "compiling(re): /" + re + "/";
            }

        }

    }
}
