﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class MatchCountEqualsZero : Perusable
    {
        public override bool reading()
        {
            bool b = false;
            string fileName = label;
            string line = EMPTY;

            try
            {
                int count = 0;
                for (; ; )
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        count += 1;
                    }

                }

                if (count == 0)
                {
                    Console.WriteLine(fileName);
                }
                else
                {
                    b = true;
                }

            }
            catch (IOException e62)
            {
                Error.handler(e62.ToString());
                plus("IOException e62");
            }

            return b;
        }

        public override bool reading(string fileName)
        {
            bool b = false;

            try
            {
                int count = 0;
                StreamReader file = new StreamReader(fileName, Encoding.Default);
                string line = EMPTY;

                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        count += 1;
                    }

                }

                file.Close();
                if (count == 0)
                {
                    Console.WriteLine(fileName);
                }
                else
                {
                    b = true;
                }

            }
            catch (IOException e63)
            {
                Error.handler(e63.ToString());
                plus("IOException e63");
            }

            return b;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool b = false;

            try
            {
                int count = 0;
                StreamReader file = new StreamReader(fileName, encoding);
                string line = EMPTY;
                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        count += 1;
                    }

                }

                file.Close();
                if (count == 0)
                {
                    Console.WriteLine(fileName);
                }
                else
                {
                    b = true;
                }

            }
            catch (IOException e64)
            {
                Error.handler(e64.ToString());
                plus("IOException e64");
            }

            return b;
        }

        public MatchCountEqualsZero(string re, bool insensitive)
        {
            case_sensitive = !insensitive;

            if (compiling(re))
            {
                error = EMPTY;
            }
            else
            {
                error = "compiling(re): /" + re + "/";
            }

        }

    }
}
