﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class MultiPatternFileLine : Perusable
    {
        int patternCount;
        Regex bellCompiled;
        Regex[] compiled;
        string[] pattern;

        public override bool reading()
        {
            bool b = false;
            string fileNameSeparator = label + separator;
            string line = EMPTY;

            try
            {
                for (; ; )
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            b = true;
                            Console.Write(fileNameSeparator);
                            Console.WriteLine(line);
                            break;
                        }

                    }

                }

            }
            catch (IOException e97)
            {
                Error.handler(e97.ToString());
                plus("IOException e97");
            }

            return b;
        }

        public override bool reading(string fileName)
        {
            bool b = false;
            string fileNameSeparator = fileName + separator;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);

                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            b = true;
                            Console.Write(fileNameSeparator);
                            Console.WriteLine(line);
                            break;
                        }

                    }

                }

                file.Close();
            }
            catch (IOException e98)
            {
                Error.handler(e98.ToString());
                plus("IOException e98");
            }

            return b;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool b = false;
            string fileNameSeparator = fileName + separator;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, encoding);

                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            b = true;
                            Console.Write(fileNameSeparator);
                            Console.WriteLine(line);
                            break;
                        }

                    }

                }

                file.Close();
            }
            catch (IOException e99)
            {
                Error.handler(e99.ToString());
                plus("IOException e99");
            }

            return b;
        }

        public MultiPatternFileLine(string[] pn, bool insensitive)
        {
            case_sensitive = !insensitive;

            compiling(BELL);
            bellCompiled = x; // x = new Regex(re)

            error = EMPTY;
            patternCount = pn.Length;
            compiled = new Regex[patternCount];
            pattern = new string[patternCount];

            try
            {
                Array.Copy(pn, 0, pattern, 0, patternCount);
            }
            catch (ArgumentException e100)
            {
                Error.handler(e100.ToString());
                plus("ArgumentException e100");
            }

            int error_contained = 0;
            for (int i = 0; i < patternCount && error_contained < MANY_TIMES; ++i)
            {
                if (compiling(pattern[i]))
                {
                    compiled[i] = x;
                }
                else
                {
                    compiled[i] = bellCompiled;
                    plus("/" + pattern[i] + "/");
                    error_contained += 1;
                }

            }

            if (error_contained == MANY_TIMES)
            {
                patternCount = MANY_TIMES;
            }

        }

    }
}
