﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class MultiPatternFileRequired : Perusable
    {
        int patternCount;
        Regex bellCompiled;
        Regex[] compiled;
        string[] pattern;

        public override bool reading()
        {
            string fileName = label;
            string line = EMPTY;

            try
            {
                for (; ; )
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            Console.WriteLine(fileName);
                            return true;
                        }

                    }

                }

            }
            catch (IOException e36)
            {
                Error.handler(e36.ToString());
                plus("IOException e36");
            }

            return false;
        }

        public override bool reading(string fileName)
        {
            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);
                string line = EMPTY;

                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            Console.WriteLine(fileName);
                            file.Close();
                            return true;
                        }

                    }

                }

                file.Close();
            }
            catch (IOException e37)
            {
                Error.handler(e37.ToString());
                plus("IOException e37");
            }

            return false;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            try
            {
                StreamReader file = new StreamReader(fileName, encoding);
                string line = EMPTY;

                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            Console.WriteLine(fileName);
                            file.Close();
                            return true;
                        }

                    }

                }

                file.Close();
            }
            catch (IOException e38)
            {
                Error.handler(e38.ToString());
                plus("IOException e38");
            }

            return false;
        }

        public MultiPatternFileRequired(string[] pn, bool insensitive)
        {
            case_sensitive = !insensitive;

            compiling(BELL);
            bellCompiled = x; // x = new Regex(re)

            error = EMPTY;
            patternCount = pn.Length;
            compiled = new Regex[patternCount];
            pattern = new string[patternCount];

            try
            {
                Array.Copy(pn, 0, pattern, 0, patternCount);
            }
            catch (ArgumentException e39)
            {
                Error.handler(e39.ToString());
                plus("ArgumentException e39");
            }

            int error_contained = 0;
            for (int i = 0; i < patternCount && error_contained < MANY_TIMES; ++i)
            {
                if (compiling(pattern[i]))
                {
                    compiled[i] = x;
                }
                else
                {
                    compiled[i] = bellCompiled;
                    plus("/" + pattern[i] + "/");
                    error_contained += 1;
                }

            }

            if (error_contained == MANY_TIMES)
            {
                patternCount = MANY_TIMES;
            }

        }

    }
}
