﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class MultiPatternLineLimitedRing : Perusable
    {
        int after, maximumLineCount, patternCount, ring_count;
        Queue<string> ring = new Queue<string>();
        Regex bellCompiled;
        Regex[] compiled;
        string[] pattern;

        private void prepareRing()
        {
            ring.Clear();
            for (int i = 0; i < ring_count; ++i)
            {
                ring.Enqueue(GAP);
            }

        }

        private void showRing()
        {
            foreach (string s in ring)
            {
                Console.WriteLine(s);
            }

            Console.WriteLine(DASH);
        }

        public override bool reading()
        {
            bool found = false;
            bool written = false;
            int matchCount = 0;
            string line = EMPTY;
            prepareRing();

            try
            {
                if (after > 0)
                {
                    int count = 0;
                    for (; ; )
                    {
                        line = Console.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        if (found)
                        {
                            count += 1;
                            if (count >= after)
                            {
                                showRing();
                                prepareRing();
                                written = true;
                                if (matchCount < maximumLineCount)
                                {
                                    count = 0;
                                    found = false;
                                }
                                else
                                {
                                    break;
                                }

                            }

                        }

                        foreach (Regex x in compiled)
                        {
                            m = x.Match(line);
                            if (inverted ^ m.Success)
                            {
                                found = true;
                                matchCount += 1;
                                break;
                            }

                        }

                    }

                }
                else
                {
                    while(matchCount < maximumLineCount)
                    {
                        line = Console.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        foreach (Regex x in compiled)
                        {
                            m = x.Match(line);
                            if (inverted ^ m.Success)
                            {
                                found = true;
                                matchCount += 1;
                                showRing();
                                prepareRing();
                                written = true;
                                break;
                            }

                        }

                    }

                }

                if (found)
                {
                    if (written)
                    {
                        ;
                    }
                    else
                    {
                        showRing();
                        written = true;
                    }

                }
                else
                {
                    found = (matchCount > 0) ? true : false;
                }

            }
            catch (InvalidOperationException e150)
            {
                Error.handler(e150.ToString());
                plus("InvalidOperationException e150");
                Console.Error.WriteLine(label);
            }
            catch (IOException e140)
            {
                Error.handler(e140.ToString());
                plus("IOException e140");
            }

            return found;
        }

        public override bool reading(string fileName)
        {
            bool found = false;
            bool written = false;
            int matchCount = 0;
            string line = EMPTY;
            prepareRing();

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);

                if (after > 0)
                {
                    int count = 0;
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);
                        if (found)
                        {
                            count += 1;
                            if (count >= after)
                            {
                                showRing();
                                prepareRing();
                                written = true;
                                if (matchCount < maximumLineCount)
                                {
                                    count = 0;
                                    found = false;
                                }
                                else
                                {
                                    break;
                                }

                            }

                        }

                        foreach (Regex x in compiled)
                        {
                            m = x.Match(line);
                            if (inverted ^ m.Success)
                            {
                                found = true;
                                matchCount += 1;
                                break;
                            }

                        }

                    }

                }
                else
                {
                    while(matchCount < maximumLineCount)
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        foreach (Regex x in compiled)
                        {
                            m = x.Match(line);
                            if (inverted ^ m.Success)
                            {
                                found = true;
                                matchCount += 1;
                                showRing();
                                prepareRing();
                                written = true;
                                break;
                            }

                        }

                    }

                }

                file.Close();
                if (found)
                {
                    if (written)
                    {
                        ;
                    }
                    else
                    {
                        showRing();
                        written = true;
                    }

                }
                else
                {
                    found = (matchCount > 0) ? true : false;
                }

            }
            catch (InvalidOperationException e151)
            {
                Error.handler(e151.ToString());
                plus("InvalidOperationException e151");
                Console.Error.WriteLine(fileName);
            }
            catch (IOException e141)
            {
                Error.handler(e141.ToString());
                plus("IOException e141");
            }

            return found;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool found = false;
            bool written = false;
            int matchCount = 0;
            string line = EMPTY;
            prepareRing();

            try
            {
                StreamReader file = new StreamReader(fileName, encoding);

                if (after > 0)
                {
                    int count = 0;
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);
                        if (found)
                        {
                            count += 1;
                            if (count >= after)
                            {
                                showRing();
                                prepareRing();
                                written = true;
                                if (matchCount < maximumLineCount)
                                {
                                    count = 0;
                                    found = false;
                                }
                                else
                                {
                                    break;
                                }

                            }

                        }

                        foreach (Regex x in compiled)
                        {
                            m = x.Match(line);
                            if (inverted ^ m.Success)
                            {
                                found = true;
                                matchCount += 1;
                                break;
                            }

                        }

                    }

                }
                else
                {
                    while(matchCount < maximumLineCount)
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        foreach (Regex x in compiled)
                        {
                            m = x.Match(line);
                            if (inverted ^ m.Success)
                            {
                                found = true;
                                matchCount += 1;
                                showRing();
                                prepareRing();
                                written = true;
                                break;
                            }

                        }

                    }

                }

                file.Close();
                if (found)
                {
                    if (written)
                    {
                        ;
                    }
                    else
                    {
                        showRing();
                        written = true;
                    }

                }
                else
                {
                    found = (matchCount > 0) ? true : false;
                }

            }
            catch (InvalidOperationException e152)
            {
                Error.handler(e152.ToString());
                plus("InvalidOperationException e152");
                Console.Error.WriteLine(fileName);
            }
            catch (IOException e142)
            {
                Error.handler(e142.ToString());
                plus("IOException e142");
            }

            return found;
        }

        public MultiPatternLineLimitedRing(string[] pn, int a, int before, int m, bool insensitive)
        {
            after = a;
            case_sensitive = !insensitive;
            ring_count = before + 1 + after;

            compiling(BELL);
            bellCompiled = x; // x = new Regex(re)

            error = EMPTY;
            maximumLineCount = m;
            patternCount = pn.Length;
            compiled = new Regex[patternCount];
            pattern = new string[patternCount];

            try
            {
                Array.Copy(pn, 0, pattern, 0, patternCount);
            }
            catch (ArgumentException e143)
            {
                Error.handler(e143.ToString());
                plus("ArgumentException e143");
            }

            int error_contained = 0;
            for (int i = 0; i < patternCount && error_contained < MANY_TIMES; ++i)
            {
                if (compiling(pattern[i]))
                {
                    compiled[i] = x;
                }
                else
                {
                    compiled[i] = bellCompiled;
                    plus("/" + pattern[i] + "/");
                    error_contained += 1;
                }

            }

            if (error_contained == MANY_TIMES)
            {
                patternCount = MANY_TIMES;
            }

        }

    }
}
