﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class MultiPatternLineRing : Perusable
    {
        int after, patternCount, ring_count;
        Queue<string> ring = new Queue<string>();
        Regex bellCompiled;
        Regex[] compiled;
        string[] pattern;

        private void prepareRing()
        {
            ring.Clear();
            for (int i = 0; i < ring_count; ++i)
            {
                ring.Enqueue(GAP);
            }

        }

        private void showRing()
        {
            foreach (string s in ring)
            {
                Console.WriteLine(s);
            }

            Console.WriteLine(DASH);
        }

        public override bool reading()
        {
            bool found = false;
            bool written = false;
            int sum = 0;
            string line = EMPTY;
            prepareRing();

            try
            {
                if (after > 0)
                {
                    int count = 0;
                    for (; ; )
                    {
                        line = Console.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        if (found)
                        {
                            count += 1;
                            if (count >= after)
                            {
                                showRing();
                                prepareRing();
                                written = true;
                                count = 0;
                                found = false;
                            }

                        }

                        foreach (Regex x in compiled)
                        {
                            m = x.Match(line);
                            if (inverted ^ m.Success)
                            {
                                found = true;
                                sum += 1;
                                break;
                            }

                        }

                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = Console.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        foreach (Regex x in compiled)
                        {
                            m = x.Match(line);
                            if (inverted ^ m.Success)
                            {
                                found = true;
                                sum += 1;
                                showRing();
                                prepareRing();
                                written = true;
                                break;
                            }

                        }

                    }

                }

                if (found)
                {
                    if (written)
                    {
                        ;
                    }
                    else
                    {
                        showRing();
                        written = true;
                    }

                }
                else
                {
                    found = (sum > 0) ? true : false;
                }

            }
            catch (InvalidOperationException e153)
            {
                Error.handler(e153.ToString());
                plus("InvalidOperationException e153");
                Console.Error.WriteLine(label);
            }
            catch (IOException e75)
            {
                Error.handler(e75.ToString());
                plus("IOException e75");
            }

            return found;
        }

        public override bool reading(string fileName)
        {
            bool found = false;
            bool written = false;
            int sum = 0;
            string line = EMPTY;
            prepareRing();

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);

                if (after > 0)
                {
                    int count = 0;
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);
                        if (found)
                        {
                            count += 1;
                            if (count >= after)
                            {
                                showRing();
                                prepareRing();
                                written = true;
                                count = 0;
                                found = false;
                            }

                        }

                        foreach (Regex x in compiled)
                        {
                            m = x.Match(line);
                            if (inverted ^ m.Success)
                            {
                                found = true;
                                sum += 1;
                                break;
                            }

                        }

                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        foreach (Regex x in compiled)
                        {
                            m = x.Match(line);
                            if (inverted ^ m.Success)
                            {
                                found = true;
                                sum += 1;
                                showRing();
                                prepareRing();
                                written = true;
                                break;
                            }

                        }

                    }

                }

                file.Close();
                if (found)
                {
                    if (written)
                    {
                        ;
                    }
                    else
                    {
                        showRing();
                        written = true;
                    }

                }
                else
                {
                    found = (sum > 0) ? true : false;
                }

            }
            catch (InvalidOperationException e154)
            {
                Error.handler(e154.ToString());
                plus("InvalidOperationException e154");
                Console.Error.WriteLine(fileName);
            }
            catch (IOException e76)
            {
                Error.handler(e76.ToString());
                plus("IOException e76");
            }

            return found;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool found = false;
            bool written = false;
            int sum = 0;
            string line = EMPTY;
            prepareRing();

            try
            {
                StreamReader file = new StreamReader(fileName, encoding);

                if (after > 0)
                {
                    int count = 0;
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);
                        if (found)
                        {
                            count += 1;
                            if (count >= after)
                            {
                                showRing();
                                prepareRing();
                                written = true;
                                count = 0;
                                found = false;
                            }

                        }

                        foreach (Regex x in compiled)
                        {
                            m = x.Match(line);
                            if (inverted ^ m.Success)
                            {
                                found = true;
                                sum += 1;
                                break;
                            }

                        }

                    }

                }
                else
                {
                    for (; ; )
                    {
                        line = file.ReadLine();
                        if (line == null)
                        {
                            break;
                        }

                        ring.Dequeue();
                        ring.Enqueue(line);

                        foreach (Regex x in compiled)
                        {
                            m = x.Match(line);
                            if (inverted ^ m.Success)
                            {
                                found = true;
                                sum += 1;
                                showRing();
                                prepareRing();
                                written = true;
                                break;
                            }

                        }

                    }

                }

                file.Close();
                if (found)
                {
                    if (written)
                    {
                        ;
                    }
                    else
                    {
                        showRing();
                        written = true;
                    }

                }
                else
                {
                    found = (sum > 0) ? true : false;
                }

            }
            catch (InvalidOperationException e155)
            {
                Error.handler(e155.ToString());
                plus("InvalidOperationException e155");
                Console.Error.WriteLine(fileName);
            }
            catch (IOException e77)
            {
                Error.handler(e77.ToString());
                plus("IOException e77");
            }

            return found;
        }

        public MultiPatternLineRing(string[] pn, int a, int before, bool insensitive)
        {
            after = a;
            case_sensitive = !insensitive;
            ring_count = before + 1 + after;

            compiling(BELL);
            bellCompiled = x; // x = new Regex(re)

            error = EMPTY;
            patternCount = pn.Length;
            compiled = new Regex[patternCount];
            pattern = new string[patternCount];

            try
            {
                Array.Copy(pn, 0, pattern, 0, patternCount);
            }
            catch (ArgumentException e78)
            {
                Error.handler(e78.ToString());
                plus("ArgumentException e78");
            }

            int error_contained = 0;
            for (int i = 0; i < patternCount && error_contained < MANY_TIMES; ++i)
            {
                if (compiling(pattern[i]))
                {
                    compiled[i] = x;
                }
                else
                {
                    compiled[i] = bellCompiled;
                    plus("/" + pattern[i] + "/");
                    error_contained += 1;
                }

            }

            if (error_contained == MANY_TIMES)
            {
                patternCount = MANY_TIMES;
            }

        }

    }
}
