﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class MultiPatternMatchCountEqualsZero : Perusable
    {
        int patternCount;
        Regex bellCompiled;
        Regex[] compiled;
        string[] pattern;

        public override bool reading()
        {
            bool b = false;
            string fileName = label;
            string line = EMPTY;

            try
            {
                int count = 0;
                for (; ; )
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            count += 1;
                            break;
                        }

                    }

                }

                if (count == 0)
                {
                    Console.WriteLine(fileName);
                }
                else
                {
                    b = true;
                }

            }
            catch (IOException e65)
            {
                Error.handler(e65.ToString());
                plus("IOException e65");
            }

            return b;
        }

        public override bool reading(string fileName)
        {
            bool b = false;

            try
            {
                int count = 0;
                StreamReader file = new StreamReader(fileName, Encoding.Default);
                string line;
                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            count += 1;
                            break;
                        }

                    }

                }

                file.Close();
                if (count == 0)
                {
                    Console.WriteLine(fileName);
                }
                else
                {
                    b = true;
                }

            }
            catch (IOException e66)
            {
                Error.handler(e66.ToString());
                plus("IOException e66");
            }

            return b;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool b = false;

            try
            {
                int count = 0;
                StreamReader file = new StreamReader(fileName, encoding);
                string line;
                for (; ; )
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            count += 1;
                            break;
                        }

                    }

                }

                file.Close();
                if (count == 0)
                {
                    Console.WriteLine(fileName);
                }
                else
                {
                    b = true;
                }

            }
            catch (IOException e67)
            {
                Error.handler(e67.ToString());
                plus("IOException e67");
            }

            return b;
        }

        public MultiPatternMatchCountEqualsZero(string[] pn, bool insensitive)
        {
            case_sensitive = !insensitive;

            compiling(BELL);
            bellCompiled = x; // x = new Regex(re)

            error = EMPTY;
            patternCount = pn.Length;
            compiled = new Regex[patternCount];
            pattern = new string[patternCount];

            try
            {
                Array.Copy(pn, 0, pattern, 0, patternCount);
            }
            catch (ArgumentException e68)
            {
                Error.handler(e68.ToString());
                plus("ArgumentException e68");
            }

            int error_contained = 0;
            for (int i = 0; i < patternCount && error_contained < MANY_TIMES; ++i)
            {
                if (compiling(pattern[i]))
                {
                    compiled[i] = x;
                }
                else
                {
                    compiled[i] = bellCompiled;
                    plus("/" + pattern[i] + "/");
                    error_contained += 1;
                }

            }

            if (error_contained == MANY_TIMES)
            {
                patternCount = MANY_TIMES;
            }

        }

    }
}
