﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class MultiPatternNumberLine : Perusable
    {
        int patternCount;
        Regex bellCompiled;
        Regex[] compiled;
        string[] pattern;

        public override bool reading()
        {
            bool b = false;
            string line = EMPTY;

            try
            {
                for (int lineNumber = 1; ; lineNumber += 1)
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            b = true;
                            Console.Write(lineNumber);
                            Console.Write(separator);
                            Console.WriteLine(line);
                            break;
                        }

                    }

                }

            }
            catch (IOException e86)
            {
                Error.handler(e86.ToString());
                plus("IOException e86");
            }

            return b;
        }

        public override bool reading(string fileName)
        {
            bool b = false;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);

                for (int lineNumber = 1; ; lineNumber += 1)
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            b = true;
                            Console.Write(lineNumber);
                            Console.Write(separator);
                            Console.WriteLine(line);
                            break;
                        }

                    }

                }

                file.Close();
            }
            catch (IOException e87)
            {
                Error.handler(e87.ToString());
                plus("IOException e87");
            }

            return b;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool b = false;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, encoding);

                for (int lineNumber = 1; ; lineNumber += 1)
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            b = true;
                            Console.Write(lineNumber);
                            Console.Write(separator);
                            Console.WriteLine(line);
                            break;
                        }

                    }

                }

                file.Close();
            }
            catch (IOException e88)
            {
                Error.handler(e88.ToString());
                plus("IOException e88");
            }

            return b;
        }

        public MultiPatternNumberLine(string[] pn, bool insensitive)
        {
            case_sensitive = !insensitive;

            compiling(BELL);
            bellCompiled = x; // x = new Regex(re)

            error = EMPTY;
            patternCount = pn.Length;
            compiled = new Regex[patternCount];
            pattern = new string[patternCount];

            try
            {
                Array.Copy(pn, 0, pattern, 0, patternCount);
            }
            catch (ArgumentException e89)
            {
                Error.handler(e89.ToString());
                plus("ArgumentException e89");
            }

            int error_contained = 0;
            for (int i = 0; i < patternCount && error_contained < MANY_TIMES; ++i)
            {
                if (compiling(pattern[i]))
                {
                    compiled[i] = x;
                }
                else
                {
                    compiled[i] = bellCompiled;
                    plus("/" + pattern[i] + "/");
                    error_contained += 1;
                }

            }

            if (error_contained == MANY_TIMES)
            {
                patternCount = MANY_TIMES;
            }

        }

    }
}
