﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class MultiPatternNumberLineLimited : Perusable
    {
        int maximumLineCount, patternCount;
        Regex bellCompiled;
        Regex[] compiled;
        string[] pattern;

        public override bool reading()
        {
            bool found = false;
            int count = 0;
            string line = EMPTY;

            try
            {
                for (int lineNumber = 1; count < maximumLineCount; lineNumber += 1)
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            Console.Write(lineNumber);
                            Console.Write(separator);
                            Console.WriteLine(line);
                            count += 1;
                            break;
                        }

                    }

                }

                if(count > 0) {
                    found = true;
                }

            }
            catch (IOException e156)
            {
                Error.handler(e156.ToString());
                plus("IOException e156");
            }

            return found;
        }

        public override bool reading(string fileName)
        {
            bool found = false;
            int count = 0;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);

                for (int lineNumber = 1; count < maximumLineCount; lineNumber += 1)
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            Console.Write(lineNumber);
                            Console.Write(separator);
                            Console.WriteLine(line);
                            count += 1;
                            break;
                        }

                    }

                }

                file.Close();
                if(count > 0) {
                    found = true;
                }

            }
            catch (IOException e157)
            {
                Error.handler(e157.ToString());
                plus("IOException e157");
            }

            return found;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool found = false;
            int count = 0;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, encoding);

                for (int lineNumber = 1; count < maximumLineCount; lineNumber += 1)
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    foreach (Regex x in compiled)
                    {
                        m = x.Match(line);
                        if (inverted ^ m.Success)
                        {
                            Console.Write(lineNumber);
                            Console.Write(separator);
                            Console.WriteLine(line);
                            count += 1;
                            break;
                        }

                    }

                }

                file.Close();
                if(count > 0) {
                    found = true;
                }

            }
            catch (IOException e158)
            {
                Error.handler(e158.ToString());
                plus("IOException e158");
            }

            return found;
        }

        public MultiPatternNumberLineLimited(string[] pn, int m, bool insensitive)
        {
            case_sensitive = !insensitive;

            compiling(BELL);
            bellCompiled = x; // x = new Regex(re)

            error = EMPTY;
            maximumLineCount = m;
            patternCount = pn.Length;
            compiled = new Regex[patternCount];
            pattern = new string[patternCount];

            try
            {
                Array.Copy(pn, 0, pattern, 0, patternCount);
            }
            catch (ArgumentException e159)
            {
                Error.handler(e159.ToString());
                plus("ArgumentException e159");
            }

            int error_contained = 0;
            for (int i = 0; i < patternCount && error_contained < MANY_TIMES; ++i)
            {
                if (compiling(pattern[i]))
                {
                    compiled[i] = x;
                }
                else
                {
                    compiled[i] = bellCompiled;
                    plus("/" + pattern[i] + "/");
                    error_contained += 1;
                }

            }

            if (error_contained == MANY_TIMES)
            {
                patternCount = MANY_TIMES;
            }

        }

    }
}
