﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AceGrep
{
    public class NumberLineLimited : Perusable
    {
        int maximumLineCount;

        public override bool reading()
        {
            bool found = false;
            int count = 0;
            string line = EMPTY;

            try
            {
                for (int lineNumber = 1; count < maximumLineCount; lineNumber += 1)
                {
                    line = Console.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        Console.Write(lineNumber);
                        Console.Write(separator);
                        Console.WriteLine(line);
                        count += 1;
                    }

                }

                if(count > 0) {
                    found = true;
                }

            }
            catch (IOException e121)
            {
                Error.handler(e121.ToString());
                plus("IOException e121");
            }

            return found;
        }

        public override bool reading(string fileName)
        {
            bool found = false;
            int count = 0;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, Encoding.Default);

                for (int lineNumber = 1; count < maximumLineCount; lineNumber += 1)
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        Console.Write(lineNumber);
                        Console.Write(separator);
                        Console.WriteLine(line);
                        count += 1;
                    }

                }

                file.Close();
                if(count > 0) {
                    found = true;
                }

            }
            catch (IOException e122)
            {
                Error.handler(e122.ToString());
                plus("IOException e122");
            }

            return found;
        }

        public override bool reading(string fileName, Encoding encoding)
        {
            bool found = false;
            int count = 0;
            string line = EMPTY;

            try
            {
                StreamReader file = new StreamReader(fileName, encoding);

                for (int lineNumber = 1; count < maximumLineCount; lineNumber += 1)
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    m = x.Match(line);
                    if (inverted ^ m.Success)
                    {
                        Console.Write(lineNumber);
                        Console.Write(separator);
                        Console.WriteLine(line);
                        count += 1;
                    }

                }

                file.Close();
                if(count > 0) {
                    found = true;
                }

            }
            catch (IOException e123)
            {
                Error.handler(e123.ToString());
                plus("IOException e123");
            }

            return found;
        }

        public NumberLineLimited(string re, int m, bool insensitive)
        {
            case_sensitive = !insensitive;

            maximumLineCount = m;
            if (compiling(re))
            {
                error = EMPTY;
            }
            else
            {
                error = "compiling(re): /" + re + "/";
            }

        }

    }
}
