﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace AceGrep
{
    class TimeName
    {
        const string HYPHEN = "-";
        const string SERIAL_TEXT = "serial.txt";
        const int NOT_CONVERTED = -1;
        Singleton singleton;
        string basis, extension, error, name, timeName;
        int minute, second;

        private int sequence_to_integer(string s)
        {
            int result = NOT_CONVERTED;

            try
            {
                result = Convert.ToInt32(s);
            }
            catch (FormatException e49)
            {
                Error.handler(e49.ToString());
                error = "FormatException e49";
            }

            return result;
        }

        public TimeName(string b, string e)
        {
            basis = b;
            extension = e;
            name = basis;
            singleton = Singleton.get_instance();
            readSerialNumber();
        }

        public string getTimeName()
        {
            return timeName;
        }

        public void readSerialNumber()
        {
            string s;

            try
            {
                StreamReader file = new StreamReader(SERIAL_TEXT, System.Text.Encoding.Default);

                s = file.ReadLine();
                file.Close();
                if (s == null)
                {
                    zeroSerialNumber();
                    return;
                }

                int data = sequence_to_integer(s);
                singleton.setTo(data);
            }
            catch (IOException e50)
            {
                Error.handler(e50.ToString());
                zeroSerialNumber();
            }

        }

        public bool setSerialNumber()
        {
            bool b = true;
            int sn = singleton.increment();

            try
            {
                // Writing the serial number
                StreamWriter file = File.CreateText(SERIAL_TEXT);
                file.WriteLine(sn);
                file.Close();

                // First part of a file name
                StringBuilder h = new StringBuilder();
                h.Append(basis);
                h.Append(sn);
                h.Append(HYPHEN);
                name = h.ToString();
            }
            catch (IOException e51)
            {
                b = false;
                Error.handler(e51.ToString());
                error = "IOException e51";
            }

            return b;
        }

        public string messages()
        {
            return error;
        }

        public string temporaryName(bool serial)
        {
            DateTime now = DateTime.Now;
            minute = now.Minute;
            second = now.Second;

            if (serial)
            {
                setSerialNumber();
            }

            StringBuilder h = new StringBuilder();
            h.Append(name);
            h.Append(minute);
            h.Append(HYPHEN);
            h.Append(second);
            h.Append(extension);
            string ti = h.ToString();
            if (ti.CompareTo(timeName) == 0)
            {
                setSerialNumber();

                StringBuilder y = new StringBuilder();
                y.Append(name);
                y.Append(minute);
                y.Append(HYPHEN);
                y.Append(second);
                y.Append(extension);
                ti = y.ToString();
            }

            timeName = ti;
            return timeName;
        }

        public bool zeroSerialNumber()
        {
            bool b = true;
            int sn = 0;

            try
            {
                StreamWriter file = File.CreateText(SERIAL_TEXT);
                file.WriteLine(sn);
                file.Close();

                StringBuilder h = new StringBuilder();
                h.Append(basis);
                h.Append(sn);
                h.Append(HYPHEN);
                name = h.ToString();
            }
            catch (IOException e52)
            {
                b = false;
                Error.handler(e52.ToString());
                error = "IOException e52";
            }

            return b;
        }

    }
}
