﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace SideAce
{
    public partial class Form1 : Form
    {
        const byte NEW_LINE = 0x0A;
        const double BOTTOM_ROW = 26.0;
        const double UPPER_LIMIT = 81.0;
        const double VERSION = 1.01;
        const int ASCII_SIZE = 1;
        const int BORDER = 38;
        const int BUTTON_HEIGHT = 34;
        const int BUTTON_WIDTH = 68;
        const int DIAGONAL = 3;
        const int ENCODE_UTF_8 = 3;
        const int KEYBOARD_FOCUS = 700; // milliseconds
        const int GRIP_WIDTH = 21;
        const int HEAD = 130;
        const int KANJI_SIZE = 2;
        const int MAIN_HEIGHT = 491;
        const int MAIN_WIDTH = 677;
        const int MANY_TIMES = 30;
        const int MANY_TIMES_1 = MANY_TIMES - 1;
        const int MENU_HEIGHT = 26;
        const int NON_SAMPLING_PERIOD = 300; // milliseconds
        const int NOT_CONVERTED = -1;
        const int PLUS_SIZE = 1;
        const int SLOW = 500;
        const int STATUS_BAR_HEIGHT = 23;
        const int TASK_BAR_HEIGHT = 43;
        const string ACE = "ACE";
        const string ACE_TEMP = "C:\\AceGrep\\ACE.tmp";
        const string ASCII = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~";
        const string COLON = ":";
        const string CORNER = "-c";
        const string CRLF = "\x0D\x0A";
        const string EMPTY = "";
        const string ENCODE = "-e";
        const string ERROR_TEXT = "error.txt";
        const string EUC_JP = "EUC-JP";
        const string GAP = " ";
        const string KATAKANA = "｡｢｣､･ｦｧｨｩｪｫｬｭｮｯｰｱｲｳｴｵｶｷｸｹｺｻｼｽｾｿﾀﾁﾂﾃﾄﾅﾆﾇﾈﾉﾊﾋﾌﾍﾎﾏﾐﾑﾒﾓﾔﾕﾖﾗﾘﾙﾚﾛﾜﾝﾞﾟ"; // UTF-8
        const string MS932 = "MS932";
        const string PLUS = "+";
        const string SHIFT_JIS = "Shift_JIS";
        const string UTF_8 = "UTF-8";

        bool ACE_shall_disappear = true;
        Dictionary<string, Encoding> d = new Dictionary<string, Encoding>();
        Encoding FILE_ENCODING = Encoding.Default;
        int cornerNumber = DIAGONAL;
        int encodeNumber = ENCODE_UTF_8;
        int header = (int)HEAD;
        int upperLimit = (int)UPPER_LIMIT;
        int written = 0;
        List<string> items = new List<string>();
        string CURRENT_DIRECTORY;
        string encoding = UTF_8;
        string ASCII_KATAKANA = ASCII + KATAKANA;

        public bool readAce(Encoding encoding)
        {
            bool b = false;
            int UPPER_LIMIT_1 = upperLimit - PLUS_SIZE;
            StringBuilder os = new StringBuilder();
            try
            {
                StreamReader file = new StreamReader(ACE, encoding);
                string line;
                for (int lineNumber = 1; ; lineNumber += 1)
                {
                    line = file.ReadLine();
                    if (line == null)
                    {
                        break;
                    }

                    items.Add(line);
                    line = fixedWidthFontScreenLinePlus(line, UPPER_LIMIT_1);

                    if(lineNumber <= header) {
                        os.Append(line);
                        os.Append(CRLF);
                    }

                }

                file.Close();
                string s = os.ToString();
                textBox1.Text = s;
                b = true;
                textBox1.SelectionStart = 0;
                textBox1.SelectionLength = 0;
            }
            catch (IOException e2)
            {
                Error.handler(e2.ToString());
            }

            return b;
        }

        private bool writeAce(string encoded)
        {
            bool b = true;
            byte[] data;
            Encoding e = d[encoded];

            try
            {
                FileStream file = new FileStream(ACE, FileMode.Create);

                foreach (string s in items)
                {
                    data = e.GetBytes(s);
                    file.Write(data, 0, data.Length);
                    file.WriteByte(NEW_LINE);
                }

                file.Close();
            }
            catch (IOException e3)
            {
                b = false;
                Error.handler(e3.ToString());
            }

            return b;
        }

        private int columns(int x) {
            double m_BORDER = (double)(MAIN_WIDTH - BORDER);
            double x_BORDER = (double)(x - BORDER);
            double y = x_BORDER * UPPER_LIMIT/m_BORDER;
            int z = (int)y;
            return z;
        }

        private int rows(int x) {
            double m_HEAD = (double)(MAIN_HEIGHT - HEAD);
            double x_HEAD = (double)(x - HEAD);
            double y = x_HEAD * BOTTOM_ROW/m_HEAD;
            int z = (int)y;
            return z;
        }

        private int sequence_to_integer(string s)
        {
            int a = NOT_CONVERTED;
            try
            {
                a = Convert.ToInt32(s);
            }
            catch (FormatException e4)
            {
                // ERROR_TEXT
                StreamWriter errorFile = File.CreateText(ERROR_TEXT);
                errorFile.Write("(");
                errorFile.Write(s);
                errorFile.WriteLine(")");
                errorFile.WriteLine(e4.ToString());
                errorFile.Close();
            }

            return a;
        }

        private int watchACE()
        {
            DateTime date_time = File.GetLastWriteTime(ACE);
            int q, trace;
            int w = 0;
            string e = date_time.ToString();
            /*
            2018/09/30 21:22:54
            012345678901234567890

            2018/10/01 1:22:54
            012345678901234567890
            */
            string day = e.Substring(8, 2);

            q = e.IndexOf(GAP);
            trace = q + 1;
            q = e.IndexOf(COLON);
            string hours = e.Substring(11, q - trace);

            trace = q + 1;
            q = e.LastIndexOf(COLON);
            string minutes = e.Substring(trace, q - trace);

            trace = q + 1;
            string seconds = e.Substring(trace);

            int s = sequence_to_integer(seconds);
            int m = 60 * sequence_to_integer(minutes);
            int h = 3600 * sequence_to_integer(hours);
            int d = 86400 * sequence_to_integer(day);

            w = d + h + m + s;
            if (w != written)
            {
                for (int i = 0; i < MANY_TIMES; ++i)
                {
                    if ( readAce(FILE_ENCODING) )
                    {
                        break;
                    }

                    if (i == MANY_TIMES_1)
                    {
                        ACE_shall_disappear = false;
                        Close(); // Form1_FormClosing()
                    }

                    Thread.Sleep(SLOW);
                }

            }

            return w;
        }

        private string fixedWidthFontScreenLinePlus(string line, int limit) {
            int lineLength = line.Length;
            int q;
            int size = 0;
            string c = EMPTY;
            string sequence = EMPTY;

            for (int i = 0; i < lineLength; ++i)
            {
                c = line.Substring(i, 1);
                q = ASCII_KATAKANA.IndexOf(c);
                if (q >= 0)
                {
                    size += ASCII_SIZE;
                }
                else
                {
                    size += KANJI_SIZE;
                }

                if (size > limit)
                {
                    sequence += PLUS;
                    break;
                }
                else
                {
                    sequence += c;
                }

            }

            return sequence;
        }

        private void commandLine()
        {
            int d;
            Numbered n;
            string[] commandParameters = Program.command_line_info();

            foreach (string s in commandParameters)
            {
                d = s.IndexOf(CORNER);
                if (d >= 0)
                {
                    n = new Numbered(s);
                    cornerNumber = n.number();
                    if (CORNER == n.parameter())
                    {
                        continue;
                    }

                    cornerNumber = DIAGONAL;
                }

                d = s.IndexOf(ENCODE);
                if (d >= 0)
                {
                    n = new Numbered(s);
                    encodeNumber = n.number();
                    if (ENCODE == n.parameter())
                    {
                        continue;
                    }

                    encodeNumber = ENCODE_UTF_8;
                }


            } // foreach

        }

        private void cornerHandler()
        {
            int adjuster = 0 - TASK_BAR_HEIGHT;
            int SCREEN_HEIGHT = Screen.PrimaryScreen.Bounds.Height + adjuster;
            int SCREEN_WIDTH = Screen.PrimaryScreen.Bounds.Width;

            switch (cornerNumber)
            {
                case 1: // upper left
                    Left = 0;
                    Top = 0;
                    break;
                case 2: // upper right
                    Left = SCREEN_WIDTH - Width;
                    Top = 0;
                    break;
                case 3: // lower right
                    Left = SCREEN_WIDTH - Width;
                    Top = SCREEN_HEIGHT - Height;
                    break;
                case 4: // lower left
                    Left = 0;
                    Top = SCREEN_HEIGHT - Height;
                    break;
                default: // center
                    Left = (SCREEN_WIDTH - Width) / 2;
                    Top = (SCREEN_HEIGHT - Height) / 2;
                    break;
            }

        }

        private void largeHandler()
        {
            int adjuster = 0 - TASK_BAR_HEIGHT;
            int SCREEN_HEIGHT = Screen.PrimaryScreen.Bounds.Height + adjuster;
            int SCREEN_WIDTH = Screen.PrimaryScreen.Bounds.Width;

            WindowState = FormWindowState.Normal;
            Left = 0;
            Top = 0;
            Height = SCREEN_HEIGHT;
            Width = SCREEN_WIDTH;
        }

        private void layout()
        {
            textBox1.Left = 0;
            textBox1.Top = MENU_HEIGHT;
            textBox1.Width = ClientRectangle.Width;
            textBox1.Height = ClientRectangle.Height - MENU_HEIGHT - STATUS_BAR_HEIGHT;

            toolStripStatusLabel1.Width = statusStrip1.Width - GRIP_WIDTH;

            button1.Left = statusStrip1.Width - BUTTON_WIDTH;
            button1.Top = statusStrip1.Top - BUTTON_HEIGHT;

            header = rows(Height);
            upperLimit = columns(Width);
        }

        private void standardHandler()
        {
            WindowState = FormWindowState.Normal;
            Height = MAIN_HEIGHT;
            Width = MAIN_WIDTH;
            cornerHandler();
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void versionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Version v = new Version();
            v.setVersion(VERSION.ToString());
            v.ShowDialog();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ACE_shall_disappear = true;
            Close(); // Form1_FormClosing()
        }

        private void leaveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ACE_shall_disappear = false;
            Close(); // Form1_FormClosing()
        }

        private void eUCJPToolStripMenuItem_Click(object sender, EventArgs e)
        {
            encoding = EUC_JP;
            toolStripStatusLabel1.Text = encoding;
        }

        private void shiftJISToolStripMenuItem_Click(object sender, EventArgs e)
        {
            encoding = SHIFT_JIS;
            toolStripStatusLabel1.Text = encoding;
        }

        private void uTF8ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            encoding = UTF_8;
            toolStripStatusLabel1.Text = encoding;
        }

        private void Form1_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.F3)
            {
                ACE_shall_disappear = true;
                Close(); // Form1_FormClosing()
            }
            else if (e.KeyCode == Keys.F5)
            {
                standardHandler();
            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            KeyPreview = true;
            CURRENT_DIRECTORY = Directory.GetCurrentDirectory();
            toolStripStatusLabel1.Text = CURRENT_DIRECTORY;

            d.Add(EUC_JP, Encoding.GetEncoding("euc-jp"));
            d.Add(MS932, Encoding.Default);
            d.Add(SHIFT_JIS, Encoding.GetEncoding("shift_jis"));
            d.Add(UTF_8, Encoding.UTF8);

            commandLine();
            readAce(FILE_ENCODING);
            header = rows(Height);
            upperLimit = columns(Width);
            cornerHandler();

            switch (encodeNumber)
            {
                case 1:
                    encoding = EUC_JP;
                    break;
                case 2:
                    encoding = SHIFT_JIS;
                    break;
                case 3:
                    encoding = UTF_8;
                    break;
                default:
                    encoding = UTF_8;
                    break;
            }

            timer1.Interval = NON_SAMPLING_PERIOD;
            timer1.Enabled = true;
            timer2.Interval = KEYBOARD_FOCUS;
            timer2.Enabled = true;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            written = watchACE();
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            layout();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            largeHandler();
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            button1.Focus();
            timer2.Enabled = false;
        }

        private void largeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            largeHandler();
        }

        private void standardToolStripMenuItem_Click(object sender, EventArgs e)
        {
            standardHandler();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (ACE_shall_disappear)
            {
                File.Delete(ACE);
            }
            else
            {
                writeAce(encoding);
            }

        }

        private void toolStripStatusLabel1_Click(object sender, EventArgs e)
        {
            textBox1.Text = GAP;
        }

    }
}
