﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SideAce
{
    class Numbered
    {
        const int NOT_CONVERTED = -1;
        const int NOT_FOUND = -1;
        const int TRIMMING = 1;
        const string ERROR_TEXT = "error.txt";
        const string N_0TO9 = "0123456789";
        bool trimmed;
        int a_length, non_number_length, span, trimmed_sequence_length;
        string f, ft, pt, s, st;

        private int leadingNumbers(string full)
        {
            int fullLength = full.Length;
            int k, q;
            string c;
            for (k = 0; k < fullLength; k += 1)
            {
                c = full.Substring(k, 1);
                q = N_0TO9.IndexOf(c);
                if (q >= 0)
                {
                    continue;
                }
                else
                {
                    break;
                }

            }

            return k;
        }

        private int sequence_to_integer(string s)
        {
            int a = NOT_CONVERTED;
            try
            {
                a = Convert.ToInt32(s);
            }
            catch (FormatException e5)
            {
                Error.handler(e5.ToString());
            }

            return a;
        }

        private int trailingNumbers(string full)
        {
            int fullLength = full.Length;
            int k, q, n;
            string c;
            for (n = 0; n < fullLength; n += 1)
            {
                k = fullLength - 1 - n;
                c = full.Substring(k, 1);
                q = N_0TO9.IndexOf(c);
                if (q >= 0)
                {
                    continue;
                }
                else
                {
                    break;
                }

            }

            return n;
        }

        public bool trimmed_sequence()
        {
            int u;
            /*
            a: -i1-37
            first part of a: -i1-
            second part of a: 37
            trimmed sequence: -i1
            first part of trimmed sequence: -i
            second part of trimmed sequence: 1
            */

            // Trimming the first part of a
            trimmed_sequence_length = f.Length - TRIMMING;
            pt = f.Substring(0, trimmed_sequence_length);
            trimmed = true;

            u = trailingNumbers(pt);
            if (u == 0)
            {
                trimmed = false;
                return trimmed;
            }

            span = u;
            non_number_length = trimmed_sequence_length - span;

            // Copying the second part of trimmed sequence
            st = pt.Substring(non_number_length);

            // Copying the first part of trimmed sequence
            ft = pt.Substring(0, non_number_length);
            return true;
        }

        public Numbered(string a)
        {
            trimmed = false;
            a_length = a.Length;

            span = trailingNumbers(a);
            non_number_length = a_length - span;

            // Copying the second part of a
            s = a.Substring(non_number_length);

            // Copying the first part of a
            f = a.Substring(0, non_number_length);
        }

        public string parameter()
        {
            if (trimmed)
            {
                return ft;
            }
            else
            {
                return f;
            }

        }

        public int number()
        {
            return sequence_to_integer(s);
        }

        public int subnumber()
        {
            int k = NOT_FOUND;

            if (trimmed)
            {
                k = sequence_to_integer(st);
            }

            return k;
        }

    }
}
