﻿using System;
using System.Collections.Generic;
using System.Diagnostics; // Process
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SideAce
{
    static class Program
    {
        /// <summary>
        /// アプリケーションのメイン エントリ ポイントです。
        /// </summary>
        [STAThread]
        static void Main()
        {
            checkAceSize();
            command_line_info();
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1());
        }

        public static bool checkAceSize()
        {
            bool b = true;
            const string ACE = "ACE";
            const string GAP = " ";

            try
            {
                StreamReader aceFile = new StreamReader(ACE, Encoding.Default);
                string line = aceFile.ReadLine();
                if (line == null)
                {
                    aceFile.Close();
                }
                else
                {
                    if ( line.Length > 0 )
                    {
                        aceFile.Close();
                        System.Environment.Exit(0);
                    } else {
                        aceFile.Close(); // line.Length == 0
                    }

                }

            }
            catch (IOException e6)
            {
                b = false;
                Error.handler(e6.ToString());
            }

            try
            {
                // ACE
                StreamWriter settingFile = File.CreateText(ACE);
                settingFile.Write(GAP);
                settingFile.Close();
            }
            catch (IOException e7)
            {
                b = false;
                Error.handler(e7.ToString());
            }

            return b;
        }

        private static bool deleteACE()
        {
            bool b = true;
            const string ACE = "ACE";

            try
            {
                File.Delete(ACE);
            }
            catch (IOException e10)
            {
                b = false;
                Error.handler(e10.ToString());
                Console.Error.WriteLine("IOException e10");
            }

            return b;
        }

        public static string[] command_line_info()
        {
            const bool COMMENTS = true;
            const bool WITHOUT_COMMENTS = false;
            const string COMMAND = "SideAce.exe";
            const string PDF = "-p";
            const string SIDE_ACE_PDF = "C:\\AceGrep\\AceGrep.pdf";
            const string VERSION_WITHOUT_COMMENTS = "-V";
            const string VERSION_WITH_COMMENTS = "-VC";

            int k = 0;
            int q;
            string[] arguments = Environment.GetCommandLineArgs();
            string[] parameters = { "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "" };

            foreach (string s in arguments)
            {
                if (k >= parameters.Length)
                {
                    break;
                }

                q = s.IndexOf(COMMAND);
                if (q >= 0)
                {
                    continue;
                }

                switch (s)
                {
                    case PDF:
                        Process p = new Process();
                        p.StartInfo.FileName = SIDE_ACE_PDF;
                        p.Start();
                        deleteACE();
                        System.Environment.Exit(0);
                        break;
                    case VERSION_WITH_COMMENTS:
                        versionText(COMMENTS);
                        deleteACE();
                        System.Environment.Exit(0);
                        break;
                    case VERSION_WITHOUT_COMMENTS:
                        versionText(WITHOUT_COMMENTS);
                        deleteACE();
                        System.Environment.Exit(0);
                        break;
                    default:
                        parameters[k++] = s;
                        break;
                } // switch

            } // foreach

            return parameters;
        }

        public static void versionText(bool comments)
        {
            const double VERSION = 1.01;
            const string EMPTY = "";
            const string VERSION_TEXT = "version.txt";

            // VERSION_TEXT
            StreamWriter versionFile = File.CreateText(VERSION_TEXT);
            versionFile.Write("SideAce C# Version ");
            versionFile.WriteLine(VERSION);
            versionFile.WriteLine(EMPTY);

            if (comments)
            {
                versionFile.WriteLine("SideAce -c4   # Move the SideAce window to Corner-4 ");
                versionFile.WriteLine("SideAce -e2   # 1: EUC-JP. 2: Shift_JIS. 3: UTF-8 ");
                versionFile.WriteLine("SideAce -p    # PDF help ");
                versionFile.WriteLine("SideAce -V    # version ");
                versionFile.WriteLine("SideAce -VC   # version with comments ");
            }
            else
            {
                versionFile.WriteLine("SideAce -c4   ");
                versionFile.WriteLine("SideAce -e2   ");
                versionFile.WriteLine("SideAce -p    ");
                versionFile.WriteLine("SideAce -V    ");
                versionFile.WriteLine("SideAce -VC   ");
            }

            versionFile.Close();
        }

    }
}
