#define GUIDE "newlines Version 1.01 \n\nnewlines file_name \nnewlines -c file_name \nnewlines file_name new_file \nnewlines -4 file_name \nnewlines -4 file_name new_file \nnewlines -V \n"
#define FILE_NAME_SIZE 128
#define NEW_LINES_TEXT "newlines.txt"
#define TRUE 1
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
newlines Version 1.01
Replacing two or more new-line characters with a single character (0Ah)
Copyright 2018 Sogaya
Borland C++ 5.5.1 for Win32

-----------------------------------------------------------
Before processing:
0D 0A 0D 0A
0D 0A
0A

After processing:
0A
0A
0A

-----------------------------------------------------------
-6 may be specified.
Before processing:
0D 0A 0D 0A 0D 0A

After processing:
0A

-----------------------------------------------------------
-8 may be specified.
Before processing:
0D 0A 0D 0A 0D 0A 0D 0A

After processing:
0A

*/

typedef int BOOL;

BOOL check_C(char *p) {
    BOOL b = 0; // false
    int c = *p;
    if(c == 'c') {
        b = TRUE;
    }
    
    return b;
}

BOOL check_V(char *p) {
    BOOL b = 0; // false
    int c = *p;
    if(c == 'V') {
        b = TRUE;
    }
    
    return b;
}

int reducing(FILE *file, FILE *text, int two_or_more);

int main(int argc, char *argv[]) {
    BOOL report = 0; // false
    char *p;
    char *stop;
    char file_name[FILE_NAME_SIZE];
    char new_file[FILE_NAME_SIZE];
    FILE *file;
    FILE *text;
    int lines;
    int two_or_more = 4; /* Four characters: 0D 0A 0D 0A */
    
    switch(argc) {
    case 2:
        p = argv[1];
        ++p;
        if( check_V(p) ) {
            puts(GUIDE);
            return 1;
        }
        
        strcpy(file_name, argv[1]);
        strcpy(new_file, NEW_LINES_TEXT);
        break;
    case 3:
        p = strchr(argv[1], '-');
        if(p != NULL) {
            ++p;
            if( check_V(p) ) {
                puts(GUIDE);
                return 1;
            } else if( check_C(p) ) {
                report = TRUE;
            } else {
                two_or_more = (int)strtol(p, &stop, 10);
            }
            
            strcpy(file_name, argv[2]);
            strcpy(new_file, NEW_LINES_TEXT);
        } else {
            strcpy(file_name, argv[1]);
            strcpy(new_file, argv[2]);
        }
            
        break;
    case 4:
        p = strchr(argv[1], '-');
        if(p != NULL) {
            ++p;
            if( check_V(p) ) {
                puts(GUIDE);
                return 1;
            } else if( check_C(p) ) {
                report = TRUE;
            } else {
                two_or_more = (int)strtol(p, &stop, 10);
            }
            
            strcpy(file_name, argv[2]);
            strcpy(new_file, argv[3]);
        } else {
            puts(GUIDE);
            return 1;
        }
            
        break;
    default:
        puts(GUIDE);
        return 1;
    }
    
    file = fopen(file_name, "rb");
    if(file == NULL) {
        perror("newlines");
        puts(GUIDE);
        return 1;
    }
    
    text = fopen(new_file, "wb");
    if(text == NULL) {
        perror("newlines");
        puts(GUIDE);
        return 1;
    }
    
    lines = reducing(file, text, two_or_more);
    fclose(file);
    fclose(text);
    
    if(report) {
        if(lines == 1) {
            printf("%d line\n", lines);
        } else {
            printf("%d lines\n", lines);
        }
        
    }
    
    return 0;
}

int reducing(FILE *file, FILE *text, int two_or_more) {
    BOOL coming = 0; // false
    int count = 0;
    int k;
    int lines = 0;
    int two_or_more_1 = two_or_more - 1; /* two_or_more = 4, 6, 8, 10, 12, ... */

    for(;;) {
        k = fgetc(file);
        
        switch(k) {
        case 0x0D:
            if(coming) {
                count += 1;
            } else {
                coming = TRUE;
            }
            
            break;
        case 0x0A:
            if(coming) {
                count += 1;
                if(count == two_or_more_1) {
                    fputc(0x0A, text);
                    lines += 1;
                    coming = 0; // false
                    count = 0;
                }
                
            } else {
                coming = TRUE;
            }
            
            break;
        case EOF:
            if(count == 1) {
                fputc(0x0A, text);
                lines += 1;
            }

            return lines;
        default:
            if(count == 1) {
                fputc(0x0A, text);
                lines += 1;
            }

            coming = 0; // false
            count = 0;
            fputc(k, text);
            break;
        } // switch
        
    } // for

}
