/*
obot Version 1.04
Copyright 2016 Sogaya
To express the first part of file as hexadecimal.

Borland C++ 5.5.1 for Win32

*/

#define VERSION 1.04
#define COLUMN_COUNT 20
#define FILE_NAME_SIZE 256
#define MAXIMUM_LINE_COUNT 5
#define PARAMETER_SIZE 2
#define SMALL_BUFFER_SIZE 1024
#define TRUE 1
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

typedef int BOOL;
void guide(BOOL comments);

int main(int argc, char *argv[]) {
    char *buffer;
    char *stop;
    char file_name[FILE_NAME_SIZE];
    char parameter[ PARAMETER_SIZE + 1 ];
    char small_buffer[SMALL_BUFFER_SIZE];
    const BOOL VERSION_WITH_COMMENTS = TRUE;
    const BOOL VERSION_WITHOUT_COMMENTS = 0; /* FALSE */
    FILE *file;
    FILE *test;
    int byte_count = 0;
    int new_line_count = 0;
    int code, k, maximum;
    long file_size;
    unsigned char u;

    switch(argc) {
    case 2:
        if(! strcmp(argv[1], "-VC") ) {
            guide(VERSION_WITH_COMMENTS);
            return 1;
        } else if(! strcmp(argv[1], "-V") ) {
            guide(VERSION_WITHOUT_COMMENTS);
            return 1;
        }

        maximum = MAXIMUM_LINE_COUNT;
        strcpy(file_name, argv[1]);
        break;
    case 3:
        memcpy(parameter, argv[1], PARAMETER_SIZE);
        parameter[PARAMETER_SIZE] = '\0';
        strcpy(small_buffer, argv[1] + PARAMETER_SIZE );
        strcpy(file_name, argv[2]);

        if(! strcmp(parameter, "-m") ) {
            maximum = (int)strtol(small_buffer, &stop, 10);
            if(maximum < 0) {
                maximum = MAXIMUM_LINE_COUNT;
            }

        } else {
            guide(VERSION_WITHOUT_COMMENTS);
            return 1;
        }

        break;
    default:
        guide(VERSION_WITHOUT_COMMENTS);
        return 1;
    }

/* Using the file as binary */
    test = fopen(file_name, "rb");
    if(test == NULL) {
        perror(file_name);
        return 1;
    }

    fseek(test, 0, SEEK_END);
    file_size = (long)ftell(test);
    fclose(test);

    buffer = malloc( file_size + 1 );
    if(buffer == NULL) {
        guide(VERSION_WITHOUT_COMMENTS);
        return 1;
    }

/* Re-opening  */
    file = fopen(file_name, "rb");
    fread(buffer, 1, file_size, file);
    for(k = 0; k < file_size && new_line_count < maximum; k++) {
        if(buffer[k] == 0x0A) {
            new_line_count += 1;
        }

        u = (unsigned char)buffer[k];
        code = (int)u;
        printf("%02X ", code);
        byte_count += 1;
        if(byte_count >= COLUMN_COUNT) {
            byte_count = 0;
            printf("\n");
        }

    }

    fclose(file);
    free(buffer);
    return 0;
}

void guide(int comments) {
    if(comments) {
        fprintf(stderr, "obot Version %1.3f\n\n", VERSION);
        fprintf(stderr, "obot -m3 file_name # Express 3 lines in hexadecimal notation. \n");
        fprintf(stderr, "obot -V            # version \n");
        fprintf(stderr, "obot -VC           # version with comments \n");
        fprintf(stderr, "obot file_name     # Express the first part of file as hexadecimal. \n");
    } else {
        fprintf(stderr, "obot Version %1.3f\n\n", VERSION);
        fprintf(stderr, "obot -m3 file_name ");
        fprintf(stderr, "obot -V            ");
        fprintf(stderr, "obot -VC           ");
        fprintf(stderr, "obot file_name     ");
    }

}
