/*
ovee Version 1.03
Remove files according to remove_e.txt
Copyright 2015 Sogaya

WATCOM

*/

#define BUFFER_SIZE 256
#define REMOVE_E_TEXT "remove_e.txt"
#define TRUE 1
#define DO_NOT_REMOVE "who.txt"
#include <stdio.h>
#include <string.h>

typedef int BOOL;

void chopped(char *s) {
    char *p;

/* Removing the new-line character */
    p = strrchr(s, '\n');
    if(p != NULL) {
        *p = '\0';
    }
}

void versionMessage(void) {
    fprintf(stderr, "ovee Version 1.03 \n");
    fprintf(stderr, "\n");
    fprintf(stderr, "ovee \n");
    fprintf(stderr, "ovee -V \n");
    fprintf(stderr, "ovee -w- \n");
    fprintf(stderr, "ovee -w- who.txt \n");
}

int main(int argc, char *argv[]) {
    BOOL no_removing = 0; /* FALSE */
    char *p;
    char c[BUFFER_SIZE];
    char file_name[BUFFER_SIZE];
    char file_not_to_be_removed[BUFFER_SIZE];
    FILE *file;

    strcpy(file_name, REMOVE_E_TEXT);
    strcpy(file_not_to_be_removed, DO_NOT_REMOVE);

    switch(argc) {
    case 1:
        break;
    case 2:
        if(! strcmp(argv[1], "-V") ) {
            versionMessage();
            return 1;

        } else if(! strcmp(argv[1], "-w-") ) {
            no_removing = TRUE;
        }

        break;
    case 3:
        if(! strcmp(argv[1], "-V") ) {
            versionMessage();
            return 1;

        } else if(! strcmp(argv[1], "-w-") ) {
            no_removing = TRUE;
            strcpy(file_not_to_be_removed, argv[2]);
        }

        break;
    default:
        versionMessage();
        return 1;
    }

    file = fopen(file_name, "rt");
    if(file == NULL) {
        fprintf(stderr, "%s\n", file_name);
        return 1;
    }

    for(;;) {
        p = fgets(c, BUFFER_SIZE, file);
        if(p == NULL) {
            break;
        }

        chopped(c);
        if(no_removing) {
            if(! strcmp(c, file_not_to_be_removed) ) {
                continue;
            }

        }

        remove(c);
    }

    fclose(file);
    return 0;
}
